#include <vip_core>
#include <clientprefs>

#pragma semicolon 1
#pragma newdecls required

public Plugin myinfo =
{
	name = "[VIP] Additional",
	author = "Drumanid",
	version = "1.0.1",
	url = "Discord: Drumanid#9108"
};

enum
{
	REMOVE, FREEZE, GIVE, MENU, FREEZETIME
};

static const char g_sFeature[][] =
{
	"remove_status", "freeze_status", "give_status", "additional_menu", "freeze_status_time"
};	

Handle g_hCookieFreeze, g_hCookieGive, g_hCookieFreezeTime;
char g_sCode[MAXPLAYERS +1][8], g_sData[MAXPLAYERS +1][256];
int g_iUse[MAXPLAYERS +1], g_iTarget[MAXPLAYERS +1], g_iFreezeTime[MAXPLAYERS +1];
bool g_bFeature[MAXPLAYERS +1][3], g_bGive[MAXPLAYERS +1];

public void OnPluginStart()
{
	g_hCookieFreeze = RegClientCookie("VIP_Freeze", "Дополнительные возможности вип | Заморозка", CookieAccess_Private);
	g_hCookieGive = RegClientCookie("VIP_Give", "Дополнительные возможности вип | Полученный вип статус", CookieAccess_Private);
	g_hCookieFreezeTime = RegClientCookie("VIP_FreezeTime", "Дополнительные возможности вип | Заморозка тайм-лимит", CookieAccess_Private);
	RegConsoleCmd("sm_avip", AdditionalVipCmd);

	if(VIP_IsVIPLoaded()) VIP_OnVIPLoaded();
}

public int VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(g_sFeature[REMOVE], BOOL, HIDE);
	VIP_RegisterFeature(g_sFeature[FREEZE], BOOL, HIDE);
	VIP_RegisterFeature(g_sFeature[GIVE], BOOL, HIDE);
	VIP_RegisterFeature(g_sFeature[MENU], BOOL, SELECTABLE, OnSelectItem);
	VIP_RegisterFeature(g_sFeature[FREEZETIME], INT, HIDE);
}

public void OnPluginEnd()
{ 
	if(CanTestFeatures() && GetFeatureStatus(FeatureType_Native, "VIP_UnregisterFeature") == FeatureStatus_Available)
	{
		VIP_UnregisterFeature(g_sFeature[REMOVE]);
		VIP_UnregisterFeature(g_sFeature[FREEZE]);
		VIP_UnregisterFeature(g_sFeature[GIVE]);
		VIP_UnregisterFeature(g_sFeature[MENU]);
		VIP_UnregisterFeature(g_sFeature[FREEZETIME]);
	}
}

public int VIP_OnClientLoaded(int iClient, bool bIsVIP)
{
	if(!bIsVIP) ClearVip(iClient);
}

public int VIP_OnVIPClientLoaded(int iClient)
{
	if(g_sData[iClient][0])
	{
		g_bFeature[iClient][FREEZE] = VIP_GetClientFeatureBool(iClient, g_sFeature[FREEZE]);
		CreateTimer(0.0, TimerRemoveVip, GetClientUserId(iClient));
	}
	else
	{
		g_bFeature[iClient][REMOVE] = VIP_GetClientFeatureBool(iClient, g_sFeature[REMOVE]);
		g_bFeature[iClient][FREEZE] = VIP_GetClientFeatureBool(iClient, g_sFeature[FREEZE]);
		g_bFeature[iClient][GIVE] = VIP_GetClientFeatureBool(iClient, g_sFeature[GIVE]);
	}
}

public bool OnSelectItem(int iClient, const char[] sFeatureName)
{
	AdditionalVipMenu(iClient);
	return false;
}

public Action TimerRemoveVip(Handle hTimer, any iClient)
{
	iClient = GetClientOfUserId(iClient);
	if(iClient > 0 && IsClientInGame(iClient))
	{
		VIP_RemoveClientVIP(iClient, false, false);
		PrintToChat(iClient, "Введите \x04!avip\x01, чтобы разморозить свой вип статус!");
	}

	return Plugin_Stop;
}

public void OnClientCookiesCached(int iClient)
{
	char sBuffer[256];

	GetClientCookie(iClient, g_hCookieFreeze, sBuffer, sizeof(sBuffer));
	if(sBuffer[0]) g_sData[iClient] = sBuffer;
	else g_sData[iClient][0] = 0;

	GetClientCookie(iClient, g_hCookieGive, sBuffer, sizeof(sBuffer));
	if(sBuffer[0]) g_bGive[iClient] = view_as<bool>(StringToInt(sBuffer));
	else g_bGive[iClient] = false;

	GetClientCookie(iClient, g_hCookieFreezeTime, sBuffer, sizeof(sBuffer));
	if(sBuffer[0]) g_iFreezeTime[iClient] = StringToInt(sBuffer);
	else g_iFreezeTime[iClient] = 0;
}

public Action AdditionalVipCmd(int iClient, int iArgs)
{
	if(iClient && VIP_IsClientVIP(iClient) || g_sData[iClient][0]) AdditionalVipMenu(iClient);
	else PrintToChat(iClient, "Вы не являетесь вип игроком!");

	return Plugin_Handled;
}

void AdditionalVipMenu(int iClient)
{
	Menu hMenu = new Menu(AdditionalVipMenuItems);
	hMenu.ExitButton = true;
 
	hMenu.SetTitle("Дополнительное VIP\nЧто делать с вип статусом?\n ");

	if(g_bFeature[iClient][FREEZE])
	{
		if(g_sData[iClient][0])
		{
			hMenu.AddItem("0", "Восстановить");
			hMenu.Display(iClient, 0);
			return;
		}
		else hMenu.AddItem("0", "Заморозить(остановить время)");
	}

	if(g_bFeature[iClient][REMOVE]) hMenu.AddItem("1", "Снять");
	if(g_bFeature[iClient][GIVE])
	{
		if(g_bGive[iClient]) hMenu.AddItem("2", "Передать игроку [Получен от другого игрока]", ITEMDRAW_DISABLED);
		else hMenu.AddItem("2", "Передать игроку");
	}

	hMenu.Display(iClient, 0);
}

public int AdditionalVipMenuItems(Menu hMenu, MenuAction action, int iClient, int iItem)
{
	switch(action)
	{
		case MenuAction_End: delete hMenu;
		case MenuAction_Select:
		{
			char sItem[4];
			hMenu.GetItem(iItem, sItem, sizeof(sItem));
		 
			switch(StringToInt(sItem))
			{
				case 0:
				{
					if(g_sData[iClient][0])
					{
						Database hDatabase = view_as<Database>(VIP_GetDatabase());
						if(hDatabase != null)
						{
							char sQuery[256], sAuth[32];
							GetClientAuthId(iClient, AuthId_Engine, sAuth, sizeof(sAuth), true);
							FormatEx(sQuery, sizeof(sQuery), "SELECT `auth` FROM `vip_users` WHERE `auth` = '%s';", sAuth);
							hDatabase.Query(SQL_Callback_CheckVip, sQuery, GetClientUserId(iClient));
						}
					}
					else
					{
						char sData[64];
						if(g_iFreezeTime[iClient] > GetTime())
						{
							FormatTime(sData, sizeof(sData), "\x04%d.%m.%Y \x01/ \x04%H:%M", g_iFreezeTime[iClient]);
							PrintToChat(iClient, "Вы сможете заморозить свой статус: %s", sData);
						}
						else UseCode(iClient, FREEZE, "Вы действительно хотите заморозить вип статус?");
					}
				}
				case 1: UseCode(iClient, REMOVE, "Вы действительно хотите снять вип статус?");
				case 2:
				{
					Menu hMenu2 = new Menu(PlayerListMenuItems);
					hMenu2.ExitButton = true;
					hMenu2.SetTitle("Выберите игрока которому хотите передать вип статус\n ");

					char  sId[4], sName[32]; int iCount;
					for(int i = 1; i <= MaxClients; i++)
					{
						if(IsClientInGame(i) && IsPlayerAlive(i) && !IsFakeClient(i) && !VIP_IsClientVIP(i))
						{
							IntToString(GetClientUserId(i), sId, sizeof(sId));
							GetClientName(i, sName, sizeof(sName));
							 
							hMenu2.AddItem(sId, sName);
							iCount++;
						}
					}

					if(iCount == 0) PrintToChat(iClient, "На данный момент нет подходящих игроков!");
					hMenu2.Display(iClient, 0);
				}
			}
		}
	}
}

public int PlayerListMenuItems(Menu hMenu, MenuAction action, int iClient, int iItem)
{
	switch(action)
	{
		case MenuAction_End: delete hMenu;
		case MenuAction_Select:
		{
			char sId[4];
			hMenu.GetItem(iItem, sId, sizeof(sId));

			g_iTarget[iClient] = GetClientOfUserId(StringToInt(sId));
			UseCode(iClient, GIVE, "Вы действительно хотите отдать вип статус?");
		}
	}
}

public void SQL_Callback_CheckVip(Database hDatabase, DBResultSet hResult, const char[] sError, any iUserID)
{
	CloseHandle(hDatabase);

	if(sError[0])
	{
		LogError("SQL_Callback_CheckVip: %s", sError);
		return;
	}

	int iClient = GetClientOfUserId(iUserID);
	if(iClient)
	{
		if(hResult.FetchRow())
		{
			char sExplodeString[2][64];
			ExplodeString(g_sData[iClient], "__", sExplodeString, sizeof(sExplodeString), sizeof(sExplodeString[]));

			if(VIP_IsValidVIPGroup(sExplodeString[0]))
			{
				VIP_RemoveClientVIP(iClient, true, false);
				VIP_SetClientVIP(iClient, StringToInt(sExplodeString[1]), _, sExplodeString[0], true);
			}
			else
			{
				PrintToChat(iClient, "К сожалению \x04%s\x01 больше не существует", sExplodeString[0]);
				PrintToChat(iClient, "Обратитесь к гл.администратору за помощью!");
			}
		}
		else
		{
			PrintToChat(iClient, "Произошла ошибка, обратитесь к гл.администратору!");
			ClearVip(iClient);
		}

		g_sData[iClient][0] = 0; SetClientCookie(iClient, g_hCookieFreeze, "");
	}
}

public Action OnClientSayCommand(int iClient, const char[] sCommand, const char[] sArgs)
{
	if(g_sCode[iClient][0])
	{
		if(StrContains(g_sCode[iClient], sArgs, true) == 0)
		{
			char sGroup[64], sTime[32];
			VIP_GetClientVIPGroup(iClient, sGroup, sizeof(sGroup));

			int iTime;
			if((iTime = VIP_GetClientAccessTime(iClient)) > 0)
			{
				iTime -= GetTime();
				IntToString(iTime, sTime, sizeof(sTime));
			}
			else sTime = "неиссякаемое";
		 

			switch(g_iUse[iClient])
			{
				case REMOVE:
				{
					ClearVip(iClient);
					VIP_RemoveClientVIP(iClient, true, false);
					PrintToChat(iClient, "Вы сняли с себя вип статус!");
					VIP_LogMessage("%L | группа: %s | оставшиеся время(unix): %s | снял с себя вип статус", iClient, sGroup, sTime);
				}
				case FREEZE:
				{
					FormatEx(g_sData[iClient], sizeof(g_sData[]), "%s__%s", sGroup, sTime);
					SetClientCookie(iClient, g_hCookieFreeze, g_sData[iClient]);

					g_iFreezeTime[iClient] = GetTime() + VIP_GetClientFeatureInt(iClient, g_sFeature[FREEZETIME]);
					char sData[64]; IntToString(g_iFreezeTime[iClient], sData, sizeof(sData));
					SetClientCookie(iClient, g_hCookieFreezeTime, sData);

					VIP_RemoveClientVIP(iClient, false, false);
					//VIP_RemoveClientVIP(iClient, true, false);
					PrintToChat(iClient, "Вы заморозили себе вип статус!");
					VIP_LogMessage("%L | группа: %s | оставшиеся время(unix): %s | заморозил себе вип статус", iClient, sGroup, sTime);
				}
				case GIVE:
				{
					if(IsClientInGame(g_iTarget[iClient]) && IsPlayerAlive(g_iTarget[iClient]))
					{
						if(g_sData[g_iTarget[iClient]][0])
						{
							PrintToChat(iClient, "Вы не можете передать этому игроку вип статус!");
							PrintToChat(iClient, "Он уже имеет вип статус (остановил время)!");
						}
						else
						{
							VIP_RemoveClientVIP(iClient, true, false);
							PrintToChat(iClient, "Вы отдали свой вип статус \x04%N", g_iTarget[iClient]);
							VIP_LogMessage("%L | группа: %s | оставшиеся время(unix): %s | отдал свой вип статус игроку %L", iClient, sGroup, sTime, g_iTarget[iClient]);
							VIP_SetClientVIP(g_iTarget[iClient], iTime, _, sGroup, true);
							g_bGive[g_iTarget[iClient]] = true;
							SetClientCookie(g_iTarget[iClient], g_hCookieGive, "1");
							PrintToChat(g_iTarget[iClient], "Вы получили вип статус от \x04%N", iClient);
						}
					}
					else PrintToChat(iClient, "Данного игрока нет на сервере!");
				}
			}
		}
		else if(StrContains(sArgs, "отмена", true) == 0)
		{
			PrintToChat(iClient, "Вы отменили действие!");
		}
		else PrintToChat(iClient, "Вы ввели неправильное значение... Отказано!");

		g_sCode[iClient][0] = 0;
		return Plugin_Handled;
	}

	return Plugin_Continue;
}

public void OnClientDisconnect(int iClient)
{
	g_sCode[iClient][0] = 0;
	g_sData[iClient][0] = 0;
	g_iFreezeTime[iClient] = 0;
	g_bGive[iClient] = false;
	for(int i; i < 3; i++) g_bFeature[iClient][i] = false;
}

void UseCode(int iClient, int iUse, char[] sMessage)
{
	g_iUse[iClient] = iUse;
	FormatEx(g_sCode[iClient], sizeof(g_sCode[]), "%i%i%i%i", GetRandomInt(0, 9), GetRandomInt(0, 9), GetRandomInt(0, 9), GetRandomInt(0, 9));
	PrintToChat(iClient, sMessage);
	PrintToChat(iClient, "Введи в чат \x04%s\x01, чтобы подтвердить свое действие", g_sCode[iClient]);
	PrintToChat(iClient, "Либо введите \x04отмена\x01, чтобы отменить дейтсвие", g_sCode[iClient]);
}

void ClearVip(int iClient)
{
	g_bGive[iClient] = false;
	SetClientCookie(iClient, g_hCookieGive, "0");

	g_iFreezeTime[iClient] = 0;
	SetClientCookie(iClient, g_hCookieFreezeTime, "0");
}